package dht;

import java.net.*;
import java.io.*;

import javax.swing.JOptionPane;

public class FileSender implements Runnable{
	
	private File newFile;
	private String fileName;
	private ServerSocket servSocket;
	private Socket newSocket;
	private DHTNetwork dht;

	public FileSender(File newFile, DHTNetwork dht)
	{
		this.newFile = newFile;
		this.fileName = newFile.getName();
		this.dht = dht;
		
		try {
			servSocket = new ServerSocket(0);
		} catch (IOException e) {
			System.out.println("File could not be sent.");
		}
	}
	
	public void run()
	{
		if(!newFile.exists())
		{
			return;
		}
		try
		{
			servSocket.setSoTimeout(10000);
			Socket newSocket = servSocket.accept();
			byte[] byteArray = new byte[(int)newFile.length()];
			BufferedInputStream bufferedInput = new BufferedInputStream(new FileInputStream(newFile));
			
			bufferedInput.read(byteArray, 0, byteArray.length);
			OutputStream output = newSocket.getOutputStream();
			output.write(byteArray, 0, byteArray.length);
			output.flush();
			newSocket.close();
			servSocket.close();
			System.out.println("Finishing sending file: " + fileName + " (" + dht.hash(fileName) + ").");
			if(dht.isTransferring())
			{
				dht.removeFileName(fileName);
			}
			else
			{
				JOptionPane.showMessageDialog(null, "Finishing sending file: " + fileName + "(" + dht.hash(fileName) + ").");
			}
		}
		catch(IOException ioException)
		{
			System.out.println("File: " + fileName + " (" + dht.hash(fileName) + ") could not be sent.");
			if(dht.isTransferring())
			{
				dht.removeFileName(fileName);
			}
			else
			{
				JOptionPane.showMessageDialog(null, "File: " + fileName + " (" + dht.hash(fileName) + ") could not be sent.");
			}
		}
	}
	
	public int getPort()
	{
		return servSocket.getLocalPort();
	}
}
